#!/usr/bin/env python
# ~*~ coding: utf-8 ~*~

# Pong-Klon
# Copyright © 2014  Tim Fuchs
#                   Tom Jung
#                   Tim Busch
#                   Yannis Noah Laurent Rump-Schnippering
#                   Mervan Aksoy
#                   Eike Tim Jesinghaus <eike.jesinghaus@teckids.org>
#                   Kevin Arutyunyan <kevin.arutyunyan@teckids.org>
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program. If not, see <http://www.gnu.org/licenses/>.

from random import randint
from ball import Ball
from schlaeger import Schlaeger

import pygame

screen = pygame.display.set_mode((620, 480))
hintergrund = pygame.image.load("hintergrund.png")
screen.blit(hintergrund, (0, 0))

controls = {
            "move_up"   : (pygame.K_UP,),
            "move_down" : (pygame.K_DOWN,),
            "exit_game" : (pygame.K_ESCAPE,)
            }

players = pygame.sprite.RenderClear()
balls = pygame.sprite.RenderClear()

player = Schlaeger((0, 0))
ball = Ball((50, 50))

players.add(player)
balls.add(ball)

while True:
    event = pygame.event.poll()
    if event.type == pygame.KEYDOWN:
        if event.key in controls["move_up"]:
            player.move = -1
        elif event.key in controls["move_down"]:
            player.move = 1
        elif event.key in controls["exit_game"]:
            exit(0)
    elif event.type == pygame.KEYUP:
        if event.key in controls["move_up"] or event.key in controls["move_down"]:
            player.move = 0

    if pygame.sprite.spritecollide(player, balls, False) or ball.rect.topleft[0] > 640 - ball.rect.height:
       ball.move[0] = -ball.move[0]

    if ball.rect.topleft[1] < 0 or ball.rect.topleft[1] > 480 - ball.rect.height:
        ball.move[1] = -ball.move[1]
    if ball.rect.topleft[0] < -50: 
        print("You failed!")
        exit(0)

    screen.blit(hintergrund, (0, 0))

    players.update()
    players.draw(screen)

    balls.update()
    balls.draw(screen)

    pygame.display.update()
